#ifndef __TRICKS__
#define __TRICKS__

  #include <conio.h>

  #include <math.h>
			  // floor(), ceil()
  #include <mem.h>
			  // memset(), movmem()
  #include <stdlib.h>
			  // abs(), rand()

#ifdef byte
#undef byte
#endif
#define byte unsigned char

template<class Type>

inline void swap( Type A, Type B )
{
   Type temp = A;
   A = B;
   B = temp;
}

#pragma aux SetMCGA =     \
            "mov eax,13h" \
            "int 10h"     \
            modify [eax];

#pragma aux SetText =     \       
            "mov eax,3h"  \
            "int 10h"     \
            modify [eax];

#pragma aux WaitRetrace =	\
          "mov dx, 3dah"   \
        "l1:"            \
          "in  al,dx"    \
          "and al,0x08"  \
          "jnz l1"       \
        "l2:"            \
          "in  al,dx"    \
          "and al,0x08"  \
          "jz  l2"       \
         modify [dx al];

void Putpixel( int x, int y, byte col, byte *screen);

#pragma aux Putpixel =              /* eax == y, ebx == x, edx == color */ \
	"mov ecx,eax"                                                          \
	"shl eax,8"                     /* y * 256                          */ \
	"shl ecx,6"                     /* y * 64                           */ \
	"add eax,ecx"                   /* y * 256 + y * 64 == y*320        */ \
	"add eax,ebx"                   /* y * 320 + x                      */ \
	"mov BYTE PTR [edi + eax], dl"                                         \
	modify [ecx]       	        /* All registers used except for
                                   those in parm[]                  */ \
	parm [ebx] [eax] [edx] [edi];

//                     //
// FUNCTION PROTOTYPES //
//                     //

  // PALLETTE FUNCTIONS
  void GrabPallette();
  void GetPal (byte ColorNo,  byte &R,
          byte &G,       byte &B);
  void Pal    (byte ColorNo,  byte R,
          byte G,        byte B);
  void RestorePallette();

  // SMALL UTILITY FUNCTIONS
  inline int  sgn  (long a);
  inline int  round(long a);

  // DRAWING FUNCTIONS
  inline void Line(int a, int b, int c, int d, int col, byte *);

//                              //
// GLOBAL VARIABLE DECLARATIONS //
//                              //

  // declare a pointer to the offset of VGA memory (prot mode)
  byte *vga = (byte *) 0xA0000;

  // This declares the PALL variable. 0 to 255 signifies the colors of the
  // pallette, 1 to 3 signifies the Red, Green and Blue values. I am
  // going to use this as a sort of "virtual pallette", and alter it
  // as much as I want, then suddenly bang it to screen. Pall2 is used
  // to "remember" the origional pallette so that we can restore it at
  // the end of the program. */
  byte Pall[256][3], Pall2[256][3];

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// GrabPallette() - This function retrieves the current pallette.          //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void GrabPallette() {

  for(int loop1=0;loop1<256;loop1++)
    GetPal(loop1,Pall2[loop1][0],Pall2[loop1][1],Pall2[loop1][2]);

}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// GetPal() - This reads the values of the Red, Green, and Blue values of  //
//            a certain color.  This function uses pass-by-reference.      //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void GetPal(byte ColorNo, byte &R,
       byte &G,      byte &B) {

  outp (0x03C7,ColorNo); // here is the pallette color I want read
  R = inp (0x03C9);
  G = inp (0x03C9);
  B = inp (0x03C9);

}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Pal() - This sets the Red, Green, and Blue values of a certain color.   //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void Pal(byte ColorNo, byte R,
    byte G,       byte B) {

  outp (0x03C8,ColorNo); // here is the pallette color I want to set
  outp (0x03C9,R);
  outp (0x03C9,G);
  outp (0x03C9,B);

}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// RestorePallette() - This function restores the origional pallette.      //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void RestorePallette() {

  WaitRetrace();
  for(int loop1=0; loop1<255; loop1++)
	 Pal(loop1,Pall2[loop1][0],Pall2[loop1][1],Pall2[loop1][2]);

}


/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// sgn() - This function is used by Line() to determine the sign of a long //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

int sgn (long a)
{
  if (a > 0)
     return +1;
  else if (a < 0)
     return -1;
  else
     return 0;

}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// round() - This function is used by Line() to round a long to the        //
//           nearest integer.                                              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

int round (long a)
{
   if ( (a - (int)a) < 0.5)
      return (int) (a);
   else
      return ceil(a);
}

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Line() - This draws a line from a,b to c,d of color col.                //
//          This function will be explained in more detail in tut3new.zip  //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void Line(int a, int b, int c, int d, int col, byte *screen) 

{

  long u,s,v,d1x,d1y,d2x,d2y,m,n,temp;
  int  i;

  u   = c-a;      // x2-x1
  v   = d-b;      // y2-y1
  d2x = d1x = sgn(u);   // d1x is the sign of u (x2-x1) (VALUE -1,0,1)
                        // d2x is the sign of u (x2-x1) (VALUE -1,0,1)
  d1y = sgn(v);   // d1y is the sign of v (y2-y1) (VALUE -1,0,1)
  d2y ^= d2y;
  m   = abs((int) u);   // m is the distance between x1 and x2
  n   = abs((int) v);   // n is the distance between y1 and y2

  if (m<=n) {     // if the x distance is greater than the y distance
    d2x ^= d2x;
    d2y = d1y;    // d2y is the sign of v (x2-x1) (VALUE -1,0,1)

    temp = m;
    m = n;        // <-- optimized..
    n = temp;

    // m   = abs((int) v); // m is the distance between y1 and y2
    // n   = abs((int) u); // n is the distance between x1 and x2
  }

  s = (int)(m >> 1); // s is the m distance (either x or y) divided by 2

  for (i=0;i<round(m);i++) { // repeat this loop until it
			     // is = to m (y or x distance)
    Putpixel(a,b,col,screen);       // plot a pixel at the original x1, y1

    s += n;                  // add n (dis of x or y) to s (dis of x of y)
	 if (s >= m) {            // if s is >= m (distance between y1 and y2)
		s -= m;
		a += (int) d1x;
		b += (int) d1y;
	 }
	 else {
		a += (int) d2x;
		b += (int) d2y;
	 }
  }
  
}

#endif
